# Users.dataSources: list

> [!NOTE]
> **Note:** Requires [authorization](https://developers.google.com/fit/rest/v1/reference/users/dataSources/list#auth).

Lists all data sources that are visible to the developer, using the OAuth
scopes provided. The list is not exhaustive; the user may have private
data sources that are only visible to other developers, or calls using
other scopes.
[Try it now](https://developers.google.com/fit/rest/v1/reference/users/dataSources/list#try-it).

## Request

### HTTP request

```
GET https://www.googleapis.com/fitness/v1/users/userId/dataSources
```

### Parameters

| Parameter name | Value | Description |
|---|---|---|
| **Path parameters** |||
| `userId` | `string` | List data sources for the person identified. Use `me` to indicate the authenticated user. Only `me` is supported at this time. |
| **Optional query parameters** |||
| `dataTypeName` | `string` | The names of data types to include in the list. If not specified, all data sources will be returned. |

### Authorization

This request requires authorization with at least one of the following scopes:

| Scope |
|---|
| `https://www.googleapis.com/auth/fitness.activity.read` |
| `https://www.googleapis.com/auth/fitness.activity.write` |
| `https://www.googleapis.com/auth/fitness.location.read` |
| `https://www.googleapis.com/auth/fitness.location.write` |
| `https://www.googleapis.com/auth/fitness.body.read` |
| `https://www.googleapis.com/auth/fitness.body.write` |
| `https://www.googleapis.com/auth/fitness.nutrition.read` |
| `https://www.googleapis.com/auth/fitness.nutrition.write` |
| `https://www.googleapis.com/auth/fitness.blood_pressure.read` |
| `https://www.googleapis.com/auth/fitness.blood_pressure.write` |
| `https://www.googleapis.com/auth/fitness.blood_glucose.read` |
| `https://www.googleapis.com/auth/fitness.blood_glucose.write` |
| `https://www.googleapis.com/auth/fitness.oxygen_saturation.read` |
| `https://www.googleapis.com/auth/fitness.oxygen_saturation.write` |
| `https://www.googleapis.com/auth/fitness.body_temperature.read` |
| `https://www.googleapis.com/auth/fitness.body_temperature.write` |
| `https://www.googleapis.com/auth/fitness.reproductive_health.read` |
| `https://www.googleapis.com/auth/fitness.reproductive_health.write` |

For more information, see the [authentication and authorization](https://developers.google.com/fit/rest/v1/authorization) page.

### Request body

Do not supply a request body with this method.

## Response

If successful, this method returns a response body with the following structure:

```
{
  "dataSource": [
    users.dataSources Resource
  ]
}
```

| Property name | Value | Description | Notes |
|---|---|---|---|
| `dataSource[]` | `list` | A previously created data source. |   |

## Try it!


Use the APIs Explorer below to call this method on live data and see the response.